#include "stdafx.h"

#include "RadioGroupScriptletPlugin.h"
#include "ScriptletConstant.h"
#include "XMLUtil.h"
#include "NRadioGroup.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_RADIOGROUP_NODE, CRadioGroupScriptletPlugin);
CRadioGroupScriptletPlugin::CRadioGroupScriptletPlugin(void)
{
}

CRadioGroupScriptletPlugin::~CRadioGroupScriptletPlugin(void)
{
}
BOOL CRadioGroupScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CNRadioGroup* pRadioGroup = dynamic_cast<CNRadioGroup*>(pTarget);
		if (pRadioGroup == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;
		
		USES_CONVERSION;

		// button
		CStringA strButtonElement = pNode->Value();
		strButtonElement.Append(".");
		strButtonElement.Append(CT2CA(SCRIPTLET_BUTTON_NODE));

		TiXmlElement* pButtonNode = pNode->FirstChildElement(strButtonElement);
		while (pButtonNode)
		{
			CContainer* pParent = pTarget->GetParent();
			ATLASSERT(IS_KIND_OF(CContainer, pParent) == TRUE);

			BOOL bPushed = FALSE;
			// pushed
			if (XMLUtil::GetAttrValue(pButtonNode, CT2CA(SCRIPTLET_PUSHED_NODE), szValue, SCRIPTLET_MAX_VALUE) || 
				XMLUtil::GetValueAsAttr(pButtonNode, CT2CA(SCRIPTLET_PUSHED_NODE), szValue, SCRIPTLET_MAX_VALUE) )
			{
				bPushed = _tcsicmp(szValue, SCRIPTLET_TRUE_VALUE) == 0;
			}

			// id
			if (XMLUtil::GetAttrValue(pButtonNode, CT2CA(SCRIPTLET_ID_NODE), szValue, SCRIPTLET_MAX_VALUE) || 
				XMLUtil::GetValueAsAttr(pButtonNode, CT2CA(SCRIPTLET_ID_NODE), szValue, SCRIPTLET_MAX_VALUE) )
			{
				CNButton* pBtn = reinterpret_cast<CNButton*>(pParent->GetComponentByName(szValue));
				pRadioGroup->AddButton(pBtn, bPushed);
			}			
			pButtonNode = pButtonNode->NextSiblingElement(strButtonElement);
		}

	}
	return bSuccess;
}
CComponent* CRadioGroupScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CNRadioGroup;
	return pComponent;
}